#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

int destructed;

class Test {
public:
	Test() { printf("Test::Test()\n"); }
	~Test() { printf("Test::~Test()\n"); destructed = 1; }
};

void *
thr(void *arg)
{
	Test t;
	pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);
	while (1)
		;
}

int
main()
{
	pthread_t td;

	pthread_create(&td, NULL, thr, NULL);
	// xxx , let the created thread enter loop....
	sleep(1);
	pthread_cancel(td);
	pthread_join(td, NULL);
	if (!destructed)
		printf("bug! object is not destructed!\n");
	else
		printf("success!\n");
	return (0);
}
