#include <pthread.h>
#include <stdio.h>

int destructed;

class Test {
public:
	Test() { printf("Test::Test()\n"); }
	~Test() { printf("Test::~Test()\n"); destructed = 1; }
};

void *
thr(void *arg)
{
	Test t;
	pthread_exit((void *)1);
}

int
main()
{
	pthread_t td;

	pthread_create(&td, NULL, thr, NULL);
	pthread_join(td, NULL);
	if (!destructed)
		printf("bug! object is not destructed!\n");
	else
		printf("success!\n");
	return (0);
}
